﻿using System;
using System.Collections;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Windows.Forms;

namespace Scrabble
{
    public partial class MainForm : Form
    {
        #region Arrays and Variables

        private string              CurrentGame = "";
        private bool                Dirty       = false;
        static  string      []      Word;
        static  string      [][]    WordByLength;
        public  TextBox     []      Board;
        static  int         []      TilePoints  = {   1,    3,    3,    2,    1,    4,    2,    4,    1,    8,    5,    1,    3,    1,    1,    3,   10,    1,    1,    1,    1,    4,    4,    8,    4,   10  };
        static  bool        []      IsBlank     = new bool[225];
        static  ResultObject[]      ResultBoard;
        static  int         []      ResultIndex;
        static  int         []      MultLetter  =
        {
            1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1,
            1, 1, 1, 1, 1, 3, 1, 1, 1, 3, 1, 1, 1, 1, 1,
            1, 1, 1, 1, 1, 1, 2, 1, 2, 1, 1, 1, 1, 1, 1,
            2, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 2,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
            1, 3, 1, 1, 1, 3, 1, 1, 1, 3, 1, 1, 1, 3, 1,
            1, 1, 2, 1, 1, 1, 2, 1, 2, 1, 1, 1, 2, 1, 1,
            1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1,
            1, 1, 2, 1, 1, 1, 2, 1, 2, 1, 1, 1, 2, 1, 1,
            1, 3, 1, 1, 1, 3, 1, 1, 1, 3, 1, 1, 1, 3, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
            2, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 2,
            1, 1, 1, 1, 1, 1, 2, 1, 2, 1, 1, 1, 1, 1, 1,
            1, 1, 1, 1, 1, 3, 1, 1, 1, 3, 1, 1, 1, 1, 1,
            1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1
        };

        static  int         []      MultWord    =
        {
            3, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 3,
            1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1,
            1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1,
            1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1,
            1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
            3, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 3,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
            1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1,
            1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1,
            1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1,
            1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1,
            3, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 3
        };

        #endregion

        #region Form

        public                  MainForm                ()
        {
            InitializeComponent();

            Board = new TextBox[225];

            for (int x = 0; x < Board.Length; x++)
            {
                this.Board[x]                   = new TextBox();
                this.Board[x].BorderStyle       = BorderStyle.FixedSingle;
                this.Board[x].CharacterCasing   = CharacterCasing.Upper;
                this.Board[x].Click            += new EventHandler(Board_GotFocus);
                this.Board[x].KeyPress         += new KeyPressEventHandler(Board_KeyPress);
                this.Board[x].Location          = new System.Drawing.Point(((x % 15) * 29) + 12, ((x / 15) * 32) + 100);
                this.Board[x].MaxLength         = 1;
                this.Board[x].Size              = new System.Drawing.Size(27, 30);
                this.Board[x].TabIndex          = x + 3;
                this.Board[x].TextAlign         = System.Windows.Forms.HorizontalAlignment.Center;
                this.Board[x].MouseDoubleClick += new MouseEventHandler(Board_DoubleClick);

                this.Controls.Add(this.Board[x]);
            }

            LoadDictionary  ();
            ColorBoard      ();
        }
        private void            MainForm_FormClosing    (object sender, FormClosingEventArgs e)
        {
            if (Dirty)
            {
                DialogResult btn = MessageBox.Show("Save this board before quitting?", "Save", MessageBoxButtons.YesNoCancel);

                if (btn == DialogResult.Yes)
                {
                    Menu_Game_Save_Click(null, null);
                }

                if (btn == DialogResult.Cancel)
                {
                    e.Cancel = true;
                }
            }
        }
        private void            CenterFields            ()
        {
            int input_width = LblLetters .Width + 8
                            + TxtLetters .Width + 8
                            + BtnAnalyze .Width + 8
                            + ChkVertical.Width;

            int input_left  = ((this.Width - input_width) >> 1);

            if (input_left  < 0)
            {
                input_left  = 0;
            }

            LblLetters .Location = new Point(input_left, LblLetters.Top);
            TxtLetters .Location = new Point(input_left + LblLetters.Width + 8, TxtLetters.Top);
            BtnAnalyze .Location = new Point(input_left + LblLetters.Width + 8 + TxtLetters.Width + 8, BtnAnalyze.Top);
            ChkVertical.Location = new Point(input_left + LblLetters.Width + 8 + TxtLetters.Width + 8 + BtnAnalyze.Width + 8, ChkVertical.Top);

            int board_width = 433 + LstResults.Width + 8;

            int board_left  = ((this.Width - board_width) >> 1);

            if (board_left  < 0)
            {
                board_left  = 0;
            }

            int cell = 0;

            for (int row = 0; row < 15; row++)
            {
                for (int col = 0; col < 15; col++)
                {
                    this.Board[cell].Location = new Point((col * 29) + board_left, this.Board[cell].Top);
                    cell++;
                }
            }

            LstResults.Left = board_left + 433 + 8;
        }

        #endregion

        #region Dictionary Functions

        private void            LoadDictionary          ()
        {
            BitStream dict = new BitStream();
            ArrayList word = new ArrayList();

            dict.LoadFromFile();

            while (!dict.AtEndOfStream)
            {
                int l = (int)((byte)  dict.ReadInteger(false,  4));
                int w = (int)((ushort)dict.ReadInteger(false, 16));

                for (int y = 0; y < w; y++)
                {
                    word.Add(dict.ReadString(l, 5));
                }
            }

            dict.Dispose();

            Word = (string[])word.ToArray(typeof(string));

            WordByLength = new string[14][];

            for (int x = 2; x <= 15; x++)
            {
                ArrayList list = new ArrayList();

                for (int w = 0; w < Word.Length; w++)
                {
                    if (Word[w].Length == x)
                    {
                        list.Add(Word[w]);
                    }
                }

                WordByLength[x - 2] = (string[])list.ToArray(typeof(string));
            }

            Progress.Maximum = Word.Length + 1;
        }
        private bool            IsValidWord             (string word)
        {
            if (word.Length < 2)
            {
                return false;
            }

            for (int x = 0; x < Word.Length; x++)
            {
                if (Word[x] == word)
                {
                    return true;
                }
            }

            return false;
        }

        #endregion

        #region Main Menu

        private void            Menu_Game_New_Click     (object sender, EventArgs e)
        {
            if (Dirty)
            {
                DialogResult btn = MessageBox.Show("Save this board before erasing it?", "Save", MessageBoxButtons.YesNoCancel);

                if (btn == DialogResult.Cancel)
                {
                    return;
                }

                if (btn == DialogResult.Yes)
                {
                    Menu_Game_Save_Click(null, null);
                }
            }

            LoadBoard                   ((new string(' ', 225)).ToCharArray(), new bool[225]);
            ColorBoard                  ();
            CurrentGame                 = "";
            ResultBoard                 = new ResultObject[0];
            ResultIndex                 = new int[0];
            this.LblResults.Text        = "";
            this.LstResults.Items.Clear ();
            this.Text                   = "Scrabble Cheater";
            this.ChkVertical.Checked    = false;
            this.TxtLetters.Text        = "";
        }
        private void            Menu_Game_Open_Click    (object sender, EventArgs e)
        {
            if (Dirty)
            {
                DialogResult btn = MessageBox.Show("Save this game before loading another one?", "Save", MessageBoxButtons.YesNoCancel);

                if (btn == DialogResult.Cancel)
                {
                    return;
                }

                if (btn == DialogResult.Yes)
                {
                    Menu_Game_Save_Click(null, null);
                }
            }

            if (DialogOpen.ShowDialog() == DialogResult.Cancel)
            {
                return;
            }

            this.Text                   = "Scrabble Cheater - " + CleanFileName(DialogOpen.FileName);
            TxtLetters.Text             = "";
            ResultBoard                 = new ResultObject[0];
            ResultIndex                 = new int[0];
            this.LblResults.Text        = "";
            this.LstResults.Items.Clear ();
            ChkVertical.Checked         = false;
            CurrentGame                 = DialogOpen.FileName;
            StreamReader file           = File.OpenText(CurrentGame);
            string       board          = file.ReadLine();

            file.Close();

            for (int x = 0; x < 225; x++)
            {
                if (board[0] == '?')
                {
                    IsBlank[x] = true;
                    board = board.Substring(1);
                }
                else
                {
                    IsBlank[x] = false;
                }

                this.Board[x].Text = board[0].ToString().Trim();
                board = board.Substring(1);
            }

            ColorBoard();
        }
        private void            Menu_Game_Save_Click    (object sender, EventArgs e)
        {
            if (CurrentGame.Length == 0)
            {
                Menu_Game_SaveAs_Click(null, null);
                return;
            }

            StreamWriter file = File.CreateText(CurrentGame);

            for (int x = 0; x < 225; x++)
            {
                if (IsBlank[x])
                {
                    file.Write("?");
                }

                file.Write(this.Board[x].Text.PadRight(1));
            }

            file.Flush();
            file.Close();
            LstResults.Items.Clear();
            Dirty = false;
        }
        private void            Menu_Game_SaveAs_Click  (object sender, EventArgs e)
        {
            if (DialogSave.ShowDialog() == DialogResult.Cancel)
            {
                return;
            }

            this.Text = "Scrabble Cheater - " + CleanFileName(DialogSave.FileName);

            CurrentGame = DialogSave.FileName;
            StreamWriter file = File.CreateText(CurrentGame);

            for (int x = 0; x < 225; x++)
            {
                if (IsBlank[x])
                {
                    file.Write("?");
                }

                file.Write(this.Board[x].Text.PadRight(1));
            }

            file.Flush();
            file.Close();
            LstResults.Items.Clear();
            Dirty = false;
        }
        private void            Menu_Game_Close_Click   (object sender, EventArgs e)
        {
            if (Dirty)
            {
                DialogResult btn = MessageBox.Show("Save this board before closing it?", "Save", MessageBoxButtons.YesNoCancel);

                if (btn == DialogResult.Cancel)
                {
                    return;
                }

                if (btn == DialogResult.Yes)
                {
                    Menu_Game_Save_Click(null, null);
                }
            }

            LoadBoard((new string(' ', 225)).ToCharArray(), new bool[225]);
            ColorBoard();
            CurrentGame                 = "";
            ResultBoard                 = new ResultObject[0];
            ResultIndex                 = new int[0];
            this.LblResults.Text        = "";
            this.LstResults.Items.Clear ();
            this.Text                   = "Scrabble Cheater";
            this.ChkVertical.Checked    = false;
            this.TxtLetters.Text        = "";
        }
        private void            Menu_Game_Exit_Click    (object sender, EventArgs e)
        {
            this.Close();
        }

        #endregion

        #region User Interface Events

        private void            Board_GotFocus                  (object sender,         EventArgs e)
        {
            int id = ((TextBox)sender).TabIndex - 3;
            this.Board[id].SelectAll();
        }
        private void            Board_KeyPress                  (object sender, KeyPressEventArgs e)
        {
            e.Handled = true;

            if   (e.KeyChar ==  13)      { e.Handled = false; BtnAnalyze_Click(null, null); return; } else
            if   (e.KeyChar <  ' ')      { e.Handled = false; } else
            if (((e.KeyChar >= 'A')  &&
                 (e.KeyChar <= 'Z')) ||
                ((e.KeyChar >= 'a')  &&
                 (e.KeyChar <= 'z')))    { e.Handled = false; }

            Dirty |= !e.Handled;

            int id = ((TextBox)sender).TabIndex - 3;

            if ((e.Handled == false) && (e.KeyChar >= 'A'))
            {
                this.Board[(id + (this.ChkVertical.Checked ? 15 : 1)) % 225].Focus();
            }
        }
        private void            Board_DoubleClick               (object sender,         EventArgs e)
        {
            int id = ((TextBox)sender).TabIndex - 3;

            IsBlank[id] = !IsBlank[id];
            Dirty = true;

            ColorBoard();
        }
        private void            BtnAnalyze_Click                (object sender,         EventArgs e)
        {
            this.BtnAnalyze.Enabled         = false;
            this.BtnAnalyze.Text            = "Analyzing...";
            this.LblResults.Text            = "";
            this.LstResults.Items.Clear     ();
            ColorBoard                      ();
            Application.DoEvents            ();

            ResultBoard                     = new ResultObject[0];
            char[]      old_board           = SaveBoard();

            GetBoards                       (old_board, TxtLetters.Text);

            this.BtnAnalyze.Text            = "Analyze";
            this.BtnAnalyze.Enabled         = true;
            this.Progress.Value             = 0;
            this.LstResults.SelectedIndex   = 0;
            this.TxtLetters.Text            = "";
            this.TxtLetters.Focus           ();
        }
        private void            TxtLetters_KeyPress             (object sender, KeyPressEventArgs e)
        {
            e.Handled = true;

            if  (e.KeyChar ==  13)      { e.Handled = false; BtnAnalyze_Click(null, null); } else
            if  (e.KeyChar <  ' ')      { e.Handled = false; } else
            if ((e.KeyChar == '?')  ||
               ((e.KeyChar >= 'A')  &&
                (e.KeyChar <= 'Z')) ||
               ((e.KeyChar >= 'a')  &&
                (e.KeyChar <= 'z')))    { e.Handled = false; }
        }
        private void            LstResults_SelectedIndexChanged (object sender,         EventArgs e)
        {
            int i = ResultIndex[LstResults.SelectedIndex];
            LoadBoard(ResultBoard[i].Board, ResultBoard[i].Blank);
            ColorBoard();
            Dirty = true;
        }
        private string          CleanFileName                   (string name)
        {
            name = name.Replace(".scrabble", "");
            name = name.Substring(name.LastIndexOf('\\') + 1);

            return name;
        }

        #endregion

        #region Board Manipulation

        private void            ColorBoard              ()
        {
            for (int x = 0; x < this.Board.Length; x++)
            {
                switch (x)
                {
                    // Triple Word Score

                    case   0:
                    case   7:
                    case  14:
                    case 105:
                    case 119:
                    case 210:
                    case 217:
                    case 224:
                    {
                        this.Board[x].BackColor = System.Drawing.Color.DarkOrange;
                        this.Board[x].ForeColor = System.Drawing.Color.White;
                        break;
                    }

                    // Double Word Score

                    case  16:
                    case  28:
                    case  32:
                    case  42:
                    case  48:
                    case  56:
                    case  64:
                    case  70:
                    case 112:
                    case 154:
                    case 160:
                    case 168:
                    case 176:
                    case 182:
                    case 192:
                    case 196:
                    case 208:
                    {
                        this.Board[x].BackColor = System.Drawing.Color.Red;
                        this.Board[x].ForeColor = System.Drawing.Color.White;
                        break;
                    }

                    // Triple Letter Score

                    case  20:
                    case  24:
                    case  76:
                    case  80:
                    case  84:
                    case  88:
                    case 136:
                    case 140:
                    case 144:
                    case 148:
                    case 200:
                    case 204:
                    {
                        this.Board[x].BackColor = System.Drawing.Color.Green;
                        this.Board[x].ForeColor = System.Drawing.Color.White;
                        break;
                    }

                    // Double Letter Score

                    case   3:
                    case  11:
                    case  36:
                    case  38:
                    case  45:
                    case  52:
                    case  59:
                    case  92:
                    case  96:
                    case  98:
                    case 102:
                    case 108:
                    case 116:
                    case 122:
                    case 126:
                    case 128:
                    case 132:
                    case 165:
                    case 172:
                    case 179:
                    case 186:
                    case 188:
                    case 213:
                    case 221:
                    {
                        this.Board[x].BackColor = System.Drawing.Color.DodgerBlue;
                        this.Board[x].ForeColor = System.Drawing.Color.White;
                        break;
                    }

                    // All Other

                    default:
                    {
                        this.Board[x].BackColor = System.Drawing.Color.Tan;
                        this.Board[x].ForeColor = System.Drawing.Color.Black;
                        break;
                    }
                }

                if (IsBlank[x])
                {
                    Color temp = this.Board[x].ForeColor;
                    this.Board[x].ForeColor = this.Board[x].BackColor;
                    this.Board[x].BackColor = temp;
                }
            }
        }
        private void            ColorBoard              (char[] tiles)
        {
            for (int x = 0; x < this.Board.Length; x++)
            {
                if (tiles[x] != ' ')
                {
                    this.Board[x].Text      = tiles[x].ToString();
                    this.Board[x].BackColor = Color.Yellow;
                    this.Board[x].ForeColor = Color.Black;
                }

                if (IsBlank[x])
                {
                    Color temp = this.Board[x].ForeColor;
                    this.Board[x].ForeColor = this.Board[x].BackColor;
                    this.Board[x].BackColor = temp;
                }
            }
        }
        private Color           Faded                   (Color  color)
        {
            byte R = (byte)((color.R + 255) >> 1);
            byte G = (byte)((color.G + 255) >> 1);
            byte B = (byte)((color.B + 255) >> 1);

            return Color.FromArgb(R, G, B);
        }
        private string          FancyBoard              (string title, char[] board)
        {
            string result = "";

            result += "-------------------------------\n";
            result += title + "\n";
            result += "-------------------------------\n\n";

            for (int row = 0; row < 15; row++)
            {
                for (int col = 0; col < 15; col++)
                {
                    result += "|" + board[(row * 15) + col].ToString();
                }

                result += "|\n";
            }

            result += "\n\n";

            return result;
        }
        private char[]          SaveBoard               ()
        {
            char[] board = new char[225];

            for (int x = 0; x < this.Board.Length; x++)
            {
                board[x] = (this.Board[x].Text.Length == 0 ? ' ' : this.Board[x].Text[0]);
            }

            return board;
        }
        private string          SaveBoardString         ()
        {
            string result = "";

            for (int x = 0; x < this.Board.Length; x++)
            {
                result += (IsBlank[x] ? "?" : "") + (this.Board[x].Text.Length == 0 ? " " : this.Board[x].Text[0].ToString());
            }

            return result;
        }
        private void            LoadBoard               (char[] board,  bool[] blank)
        {
            for (int x = 0; x < this.Board.Length; x++)
            {
                this.Board[x].Text = board[x].ToString().Trim();
                IsBlank[x] = blank[x];
            }
        }
        private void            LoadBoardString         (string board)
        {
            for (int x = 0; x < 225; x++)
            {
                if (board[0] == '?')
                {
                    IsBlank[x] = true;
                    board = board.Substring(1);
                }

                this.Board[x].Text = board[0].ToString();
                board = board.Substring(1);
            }
        }
        private void            GetBoards               (char[] board,  string tiles)
        {
            ArrayList   results     = new ArrayList();
            bool        first_turn  = ((new string(board)).Trim().Length == 0);
            int[]       available   = new int[26];
            int         blanks      = 0;

            for (int x = 0; x < tiles.Length; x++)
            {
                if (tiles[x] == '?')
                {
                    blanks++;
                }
                else
                {
                    available[(int)tiles[x] - 65]++;
                }
            }

            for (int w = 0; w < Word.Length; w++)
            {
                Progress.Value = w;
                Application.DoEvents();

                string   word   = Word[w];
                int   [] needed = new int[26];

                for (int x = 0; x < word.Length; x++)
                {
                    needed[(int)word[x] - 65]++;
                }

                for (int dir = 0; dir < 2; dir++)
                {
                    bool horizontal = (dir == 0);
                    int  offset_row = dir;
                    int  offset_col = dir ^ 1;

                    for (int y = 0; y <= (15 - word.Length); y++)
                    {
                        for (int x = 0; x < 15; x++)
                        {
                            int   row      = x;
                            int   col      = y;
                            int   pos      = 0;
                            bool  possible = true;
                            int[] needed2  = (int[])needed.Clone();

                            if (!horizontal)
                            {
                                row = y;
                                col = x;
                            }

                            while (pos < word.Length)
                            {
                                int  o = (row * 15) + col;
                                char c = board[o];

                                if (word[pos] == c)
                                {
                                    needed2[(int)c - 65]--;
                                }
                                else if (c != ' ')
                                {
                                    possible = false;
                                    break;
                                }

                                row += offset_row;
                                col += offset_col;
                                pos ++;
                            }

                            if (!possible)
                            {
                                continue;
                            }

                            int leftovers = 0;

                            for (int z = 0; z < 26; z++)
                            {
                                if (needed2[z] > available[z])
                                {
                                    leftovers += needed2[z] - available[z];
                                }
                            }

                            if (leftovers > blanks)
                            {
                                continue;
                            }

                            int [] this_avail  = (int [])available.Clone();
                            char[] this_board  = (char[])board    .Clone();
                            bool[] this_blank  = (bool[])IsBlank  .Clone();
                            int    this_blanks = blanks;
                            int    this_score  = 0;
                            bool   neighbor    = false;

                            row = (horizontal ? x : y);
                            col = (horizontal ? y : x);
                            pos = 0;

                            while (pos < word.Length)
                            {
                                int o = (row * 15) + col;
                                int l = word[pos] - 65;

                                if (!neighbor)
                                {
                                    if ((row >  0) && (board[((row - 1) * 15) + col    ] != ' ')) { neighbor = true; } else
                                    if ((row < 14) && (board[((row + 1) * 15) + col    ] != ' ')) { neighbor = true; } else
                                    if ((col >  0) && (board[ (row      * 15) + col - 1] != ' ')) { neighbor = true; } else
                                    if ((col < 14) && (board[ (row      * 15) + col + 1] != ' ')) { neighbor = true; }
                                }

                                this_board[o] = word[pos];

                                if (board[o] == ' ')
                                {
                                    if ((this_avail[l] == 0) && (this_blanks > 0))
                                    {
                                        this_blank[o] = true;
                                        this_blanks--;
                                    }
                                    else
                                    {
                                        this_avail[l]--;
                                    }
                                }

                                row += offset_row;
                                col += offset_col;
                                pos ++;
                            }

                            if ((first_turn && (this_board[112] == ' ')) || ((!first_turn) && (!neighbor)))
                            {
                                continue;
                            }

                            char[]   tile_board = GetDiffBoard (board, new string(this_board).ToCharArray());
                            char[][] word_board = GetWordBoards(this_board, tile_board);

                            if (word_board.Length == 0)
                            {
                                continue;
                            }

                            for (int z = 0; z < word_board.Length; z++)
                            {
                                this_score += GetWordScore(word_board[z], tile_board, this_blank);
                            }

                            if ((new string(tile_board)).Replace(" ", "").Length == 7)
                            {
                                this_score += 50;
                            }

                            if (this_score > 0)
                            {
                                results.Add(new ResultObject(this_board, this_blank, this_score, word_board));
                            }
                        }
                    }
                }
            }

            ResultBoard = (ResultObject[])results.ToArray(typeof(ResultObject));
            ResultIndex = new int[ResultBoard.Length];

            for (int x = 0; x < ResultIndex.Length; x++)
            {
                ResultIndex[x] = x;
            }

            for (int x = 0; x < (ResultIndex.Length - 1); x++)
            {
                for (int y = x + 1; y < ResultIndex.Length; y++)
                {
                    if (ResultBoard[ResultIndex[x]].Score < ResultBoard[ResultIndex[y]].Score)
                    {
                        ResultIndex[x] ^= ResultIndex[y];
                        ResultIndex[y] ^= ResultIndex[x];
                        ResultIndex[x] ^= ResultIndex[y];
                    }
                }
            }

            for (int x = 0; x < ResultIndex.Length; x++)
            {
                string i = string.Join(", ", ResultBoard[ResultIndex[x]].Words);
                LstResults.Items.Add(ResultBoard[ResultIndex[x]].Score.ToString().PadLeft(3) + ": " + i);
            }

            LblResults.Text  = LstResults.Items.Count.ToString() + " possible plays";
            Progress  .Value = Progress.Maximum;
        }
        private char[]          GetDiffBoard            (char[] before, char[] after)
        {
            for (int x = 0; x < before.Length; x++)
            {
                if (before[x] == after[x])
                {
                    after[x] = ' ';
                }
            }

            return after;
        }
        private char[][]        GetWordBoards           (char[] board,  char[] diff                  )
        {
            ArrayList list = new ArrayList();

            #region Horizontal Words

            for (int row = 0; row < 15; row++)
            {
                int off = row * 15;

                for (int col0 = 0; col0 < 14; col0++)
                {
                    if ((board[off + col0] == ' ') || ((col0 > 0) && (board[off + col0 - 1] != ' ')))
                    {
                        continue;
                    }

                    bool   is_new = (diff[off + col0] != ' ');
                    char[] word   = (new string(' ', 225)).ToCharArray();

                    word[off + col0] = board[off + col0];

                    for (int col1 = col0 + 1; col1 < 15; col1++)
                    {
                        if (board[off + col1] == ' ')
                        {
                            break;
                        }

                        is_new |= (diff[off + col1] != ' ');
                        word           [off + col1] = board[off + col1];
                    }

                    string wstr = (new string(word)).Replace(" ", "");

                    if ((wstr.Length > 1) && (!IsValidWord(wstr)))
                    {
                        return new char[0][];
                    }

                    if (is_new && ((new string(word)).Replace(" ", "").Length > 1))
                    {
                        list.Add(word);
                    }
                }
            }

            #endregion

            #region Vertical Words

            for (int col = 0; col < 15; col++)
            {
                for (int row0 = 0; row0 < 14; row0++)
                {
                    int off0 = row0 * 15;

                    if ((board[off0 + col] == ' ') || ((row0 > 0) && (board[((row0 - 1) * 15) + col] != ' ')))
                    {
                        continue;
                    }

                    bool   is_new = (diff[off0 + col] != ' ');
                    char[] word   = (new string(' ', 225)).ToCharArray();

                    word[off0 + col] = board[off0 + col];

                    for (int row1 = row0 + 1; row1 < 15; row1++)
                    {
                        int off1 = row1 * 15;

                        if (board[off1 + col] == ' ')
                        {
                            break;
                        }

                        is_new |= (diff[off1 + col] != ' ');
                        word[off1 + col] = board[off1 + col];
                    }

                    string wstr = (new string(word)).Replace(" ", "");

                    if ((wstr.Length > 1) && (!IsValidWord(wstr)))
                    {
                        return new char[0][];
                    }

                    if (is_new && ((new string(word)).Replace(" ", "").Length > 1))
                    {
                        list.Add(word);
                    }
                }
            }

            #endregion

            char[][] result = new char[list.Count][];

            for (int x = 0; x < list.Count; x++)
            {
                result[x] = (char[])list[x];
            }

            return result;
        }
        private int             GetWordScore            (char[] board,  char[] tiles, bool[] is_blank)
        {
            #region Horizontal Words

            for (int row = 0; row < 15; row++)
            {
                int off = row * 15;

                for (int col0 = 0; col0 < 14; col0++)
                {
                    if ((board[off + col0] == ' ') || ((col0 > 0) && (board[off + col0 - 1] != ' ')))
                    {
                        continue;
                    }

                    int    tile = 0;
                    int    mult = 1;
                    bool   new0 = (tiles[off + col0] != ' ');
                    string word =  board[off + col0].ToString();

                    if (new0)
                    {
                        int pts = 0;

                        if (!is_blank[off + col0])
                        {
                            pts = TilePoints[(int)(board[off + col0]) - 65];
                        }

                        tile += pts * MultLetter[off + col0];
                        mult *=       MultWord  [off + col0];
                    }
                    else if (!is_blank[off + col0])
                    {
                        tile += TilePoints[(int)(board[off + col0]) - 65];
                    }

                    for (int col1 = col0 + 1; (col1 < 15) && (board[off + col1] != ' '); col1++)
                    {
                        bool new1 = (tiles[off + col1] != ' ');
                        word += board[off + col1].ToString();

                        if (new1)
                        {
                            int pts = 0;

                            if (!is_blank[off + col1])
                            {
                                pts = TilePoints[(int)(board[off + col1]) - 65];
                            }

                            tile += pts * MultLetter[off + col1];
                            mult *=       MultWord  [off + col1];
                        }
                        else if (!is_blank[off + col1])
                        {
                            tile += TilePoints[(int)(board[off + col1]) - 65];
                        }
                    }

                    if (word.Length > 1)
                    {
                        return tile * mult;
                    }
                }
            }

            #endregion

            #region Vertical Words

            for (int col = 0; col < 15; col++)
            {
                for (int row0 = 0; row0 < 14; row0++)
                {
                    int off0 = row0 * 15;

                    if ((board[off0 + col] == ' ') || ((row0 > 0) && (board[((row0 - 1) * 15) + col] != ' ')))
                    {
                        continue;
                    }

                    int    tile = 0;
                    int    mult = 1;
                    bool   new0 = (tiles[off0 + col] != ' ');
                    string word =  board[off0 + col].ToString();

                    if (new0)
                    {
                        int pts = 0;

                        if (!is_blank[off0 + col])
                        {
                            pts = TilePoints[(int)(board[off0 + col]) - 65];
                        }

                        tile += pts * MultLetter[off0 + col];
                        mult *=       MultWord  [off0 + col];
                    }
                    else if (!is_blank[off0 + col])
                    {
                        tile += TilePoints[(int)(board[off0 + col]) - 65];
                    }

                    for (int row1 = row0 + 1; (row1 < 15) && (board[(row1 * 15) + col] != ' '); row1++)
                    {
                        int  off1 = row1 * 15;
                        bool new1 = (tiles[off1 + col] != ' ');
                        word     +=  board[off1 + col].ToString();

                        if (new1)
                        {
                            int pts = 0;

                            if (!is_blank[off1 + col])
                            {
                                pts = TilePoints[(int)(board[off1 + col]) - 65];
                            }

                            tile += pts * MultLetter[off1 + col];
                            mult *=       MultWord  [off1 + col];
                        }
                        else if (!is_blank[off1 + col])
                        {
                            tile += TilePoints[(int)(board[off1 + col]) - 65];
                        }
                    }

                    if (word.Length > 1)
                    {
                        return tile * mult;
                    }
                }
            }

            #endregion

            return 0;
        }
        private void            ShiftBoardLeft          (object sender, EventArgs e)
        {
            for (int row = 0; row < 15; row++)
            {
                int off = row * 15;

                string shifted_letter = Board  [off].Text;
                bool   shifted_blank  = IsBlank[off];

                for (int col = 1; col < 15; col++)
                {
                    Board  [off + col - 1].Text = Board  [off + col].Text;
                    IsBlank[off + col - 1]      = IsBlank[off + col];
                }

                Board  [off + 14].Text = shifted_letter;
                IsBlank[off + 14]      = shifted_blank;
            }

            ColorBoard();
        }
        private void            ShiftBoardUp            (object sender, EventArgs e)
        {
            for (int col = 0; col < 15; col++)
            {
                string shifted_letter = Board  [col].Text;
                bool   shifted_blank  = IsBlank[col];

                for (int row = 1; row < 15; row++)
                {
                    Board  [((row - 1) * 15) + col].Text = Board  [(row * 15) + col].Text;
                    IsBlank[((row - 1) * 15) + col]      = IsBlank[(row * 15) + col];
                }

                Board  [(14 * 15) + col].Text = shifted_letter;
                IsBlank[(14 * 15) + col]      = shifted_blank;
            }

            ColorBoard();
        }
        private void            ShiftBoardDown          (object sender, EventArgs e)
        {
            for (int col = 0; col < 15; col++)
            {
                string shifted_letter = Board  [(14 * 15) + col].Text;
                bool   shifted_blank  = IsBlank[(14 * 15) + col];

                for (int row = 13; row >= 0; row--)
                {
                    Board  [((row + 1) * 15) + col].Text = Board  [(row * 15) + col].Text;
                    IsBlank[((row + 1) * 15) + col]      = IsBlank[(row * 15) + col];
                }

                Board  [col].Text = shifted_letter;
                IsBlank[col]      = shifted_blank;
            }

            ColorBoard();
        }
        private void            ShiftBoardRight         (object sender, EventArgs e)
        {
            for (int row = 0; row < 15; row++)
            {
                int off = row * 15;

                string shifted_letter = Board  [off + 14].Text;
                bool   shifted_blank  = IsBlank[off + 14];

                for (int col = 13; col >= 0; col--)
                {
                    Board  [off + col + 1].Text = Board  [off + col].Text;
                    IsBlank[off + col + 1]      = IsBlank[off + col];
                }

                Board  [off].Text = shifted_letter;
                IsBlank[off]      = shifted_blank;
            }

            ColorBoard();
        }

        #endregion

        #region Custom Classes

        class ResultObject
        {
            public char[]   Board;
            public bool[]   Blank;
            public int      Score;
            public string[] Words;

            public ResultObject(char[] board, bool[] blank, int score, char[][] words)
            {
                this.Board = board;
                this.Blank = blank;
                this.Score = score;
                this.Words = new string[words.Length];

                for (int x = 0; x < this.Words.Length; x++)
                {
                    this.Words[x] = (new string(words[x])).Replace(" ", "");
                }
            }
        }

        #endregion
    }
}
