﻿using System;
using System.Collections;
using System.Drawing;
using System.Windows.Forms;

namespace Scrabble
{
    static class Program
    {
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new MainForm());
        }

        public static DialogResult InputBox(string title, string promptText, ref string value)
        {
            Form    form                = new Form();
            Label   label               = new Label();
            TextBox textBox             = new TextBox();
            Button  BtnAccept           = new Button();
            Button  BtnCancel           = new Button();

            form    .Text               = title;
            label   .Text               = promptText;
            textBox .Text               = value;

            BtnAccept    .Text          = "OK";
            BtnCancel    .Text          = "Cancel";
            BtnAccept    .DialogResult  = DialogResult.OK;
            BtnCancel.DialogResult      = DialogResult.Cancel;

            label       .SetBounds      (  9, 20, 372, 13);
            textBox     .SetBounds      ( 12, 36, 372, 20);
            BtnAccept   .SetBounds      (228, 72,  75, 23);
            BtnCancel   .SetBounds      (309, 72,  75, 23);

            label       .AutoSize       = true;
            textBox     .Anchor         = textBox     .Anchor | AnchorStyles.Right;
            BtnAccept   .Anchor         = AnchorStyles.Bottom | AnchorStyles.Right;
            BtnCancel   .Anchor         = AnchorStyles.Bottom | AnchorStyles.Right;

            form.ClientSize             = new Size(396, 107);
            form.Controls.AddRange      (new Control[] { label, textBox, BtnAccept, BtnCancel });
            form.ClientSize             = new Size(Math.Max(300, label.Right + 10), form.ClientSize.Height);
            form.FormBorderStyle        = FormBorderStyle.FixedDialog;
            form.StartPosition          = FormStartPosition.CenterScreen;
            form.MinimizeBox            = false;
            form.MaximizeBox            = false;
            form.AcceptButton           = BtnAccept;
            form.CancelButton           = BtnCancel;

            DialogResult dialogResult   = form.ShowDialog();
            value                       = textBox.Text;
            return dialogResult;
        }
    }
}
